
function output = Hv_LSR1(fns, x, S, Y, SS, SY, v, gamma, start_index)
    m = length(S);
    for i = 1 : m
        ind = i - 1 + start_index;
        if(ind > m)
            ind = ind - m;
        end
        YGS{i} = fns.TVaddTV(x, Y{ind}, fns.STV(x, - gamma, S{ind}));
    end
    M = SY - gamma * SS;
    V = zeros(m, 1);
    for i = 1 : m
        V(i) = fns.inpro(x, YGS{i}, v);
    end
    V = linsolve(M, V);
    output = fns.STV(x, gamma, v);
    for i = 1 : m
        output = fns.TVaddTV(x, output, fns.STV(x, V(i), YGS{i}));
    end
end
